.include "attiny15.inc"

.org	0x0000
	rjmp	RESET

.org	0x0009


.def temp = r16
.def Rx = r17
.def cnt = r18 
.equ PRx = PB3
.equ PRTS = PB2	


RESET:

	ldi temp,(1<< PB1) + (1 <<PRTS)
	out DDRB,temp				; outputs
	ldi temp,(1<< PRx)
	out PORTB,temp				; pull-up on Rx
	
	ldi temp,(1<<PWM1)+(1<<COM1A1)+(1<<CS10); PWM activate
	out TCCR1,temp				; non-inverted
	ldi temp,169				; 150 KHz
	out OCR1B,temp				;
	
	ldi temp,0x8F				; 0x8F read inside fuses	
	out OSCCAL,temp				; oscillator calibration
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PROG
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PROG:

	sbi PORTB,PRTS				; (host PC CTS) high 
PROG_1:	
	rcall GET_CHAR
	out OCR1A,Rx
	ldi temp,135
	rcall delay; 
	rjmp PROG_1					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DELAY  tempo = f(temp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DELAY:
	dec temp
	brne DELAY
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_CHAR: Receive Uart byte and put in Rx register (with hardware control)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GET_CHAR:
	cbi PORTB,PRTS				; (host PC CTS) active low	
	ldi cnt,10
	
GET_CHAR_1:

	sbic PINB,PRx
	rjmp GET_CHAR_1
	nop					; a little bit less than 
	nop					; a half period at 115200 bds
	
GET_CHAR_2:
		
	
	nop					; a little bit
	nop					; more than
	nop					; a period 
	nop					; at 115200 bds
	nop					;

	clc					; 1 cycle
	sbic PINB,PRx				; 2 / 3 cycles
	sec					; 1 cycle
	dec cnt					; 1 cycle	=> total: 9 cycles for a bit
	breq GET_CHAR_3				; 1 / 2 cycles
	ror Rx					; 1 cycle
	rjmp GET_CHAR_2				; 2 cycles

GET_CHAR_3:
	sbi PORTB,PRTS				; (host PC CTS) high
	ret 
